> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.tabs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.tabs.com/_mcp/server.

# Bulk save contract performance obligations

POST https://integrators.prod.api.tabsplatform.com/v3/contracts/{id}/performance-obligations
Content-Type: application/json

Reference: https://docs.tabs.com/api-reference/contracts/batchSavePobsForContract

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Tabs External API
  version: 1.0.0
paths:
  /v3/contracts/{id}/performance-obligations:
    post:
      operationId: integrators-api-contractsv-3-controller-batch-save-pobs-for-contract
      summary: Bulk save contract performance obligations
      tags:
        - contracts
      parameters:
        - name: id
          in: path
          description: Contract Id
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Batch save completed successfully
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Contracts_IntegratorsApiContractsv3Controller_batchSavePobsForContract_Response_200
        '400':
          description: Validation error or performance obligation features not enabled
          content:
            application/json:
              schema:
                description: Any type
        '404':
          description: Contract not found
          content:
            application/json:
              schema:
                description: Any type
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        description: >-
          Batch create, update, and delete performance obligations scoped to a
          billing term group
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BatchSavePobsForContractDto'
servers:
  - url: https://integrators.prod.api.tabsplatform.com
    description: https://integrators.prod.api.tabsplatform.com
components:
  schemas:
    ContractScopedCreatePobDtoConsiderationType:
      type: string
      enum:
        - FIXED
        - VARIABLE
      description: The consideration type for the performance obligation
      title: ContractScopedCreatePobDtoConsiderationType
    ContractScopedCreatePobDtoRecognitionPattern:
      type: string
      enum:
        - POINT_IN_TIME
        - INPUT_BASED
        - OUTPUT_BASED
        - STRAIGHT_LINE
        - RECOGNIZE_AS_CONSUMED
        - RECOGNIZE_AS_BILLED
        - SEAT_BASED_STRAIGHT_LINE
      description: The revenue recognition pattern
      title: ContractScopedCreatePobDtoRecognitionPattern
    ContractScopedCreatePobDto:
      type: object
      properties:
        name:
          type:
            - string
            - 'null'
          description: The name of the performance obligation
        itemId:
          type:
            - string
            - 'null'
          description: The ID of the associated integration item
        erpClassId:
          type:
            - string
            - 'null'
          description: The ID of the ERP class
        category:
          type:
            - string
            - 'null'
          description: The revenue category name
        considerationType:
          oneOf:
            - $ref: '#/components/schemas/ContractScopedCreatePobDtoConsiderationType'
            - type: 'null'
          description: The consideration type for the performance obligation
        recognitionPattern:
          oneOf:
            - $ref: >-
                #/components/schemas/ContractScopedCreatePobDtoRecognitionPattern
            - type: 'null'
          description: The revenue recognition pattern
        eventTypeId:
          type:
            - string
            - 'null'
          description: Event type ID for RECOGNIZE_AS_CONSUMED pattern
        productId:
          type:
            - string
            - 'null'
          description: The ID of the product this performance obligation is for
        serviceStartDate:
          type: string
          description: Service start date as YYYY-MM-DD string
        serviceEndDate:
          type: string
          description: Service end date as YYYY-MM-DD string
        transactionPrice:
          type: string
          description: Transaction price as a decimal string
      required:
        - serviceStartDate
        - serviceEndDate
        - transactionPrice
      title: ContractScopedCreatePobDto
    ContractScopedUpdatePobDtoConsiderationType:
      type: string
      enum:
        - FIXED
        - VARIABLE
      description: The consideration type for the performance obligation
      title: ContractScopedUpdatePobDtoConsiderationType
    ContractScopedUpdatePobDtoRecognitionPattern:
      type: string
      enum:
        - POINT_IN_TIME
        - INPUT_BASED
        - OUTPUT_BASED
        - STRAIGHT_LINE
        - RECOGNIZE_AS_CONSUMED
        - RECOGNIZE_AS_BILLED
        - SEAT_BASED_STRAIGHT_LINE
      description: The revenue recognition pattern
      title: ContractScopedUpdatePobDtoRecognitionPattern
    ContractScopedUpdatePobDto:
      type: object
      properties:
        id:
          type: string
          description: The ID of the performance obligation to update
        name:
          type:
            - string
            - 'null'
          description: The name of the performance obligation
        itemId:
          type:
            - string
            - 'null'
          description: The ID of the associated integration item
        erpClassId:
          type:
            - string
            - 'null'
          description: The ID of the ERP class
        category:
          type:
            - string
            - 'null'
          description: The revenue category name
        considerationType:
          oneOf:
            - $ref: '#/components/schemas/ContractScopedUpdatePobDtoConsiderationType'
            - type: 'null'
          description: The consideration type for the performance obligation
        recognitionPattern:
          oneOf:
            - $ref: >-
                #/components/schemas/ContractScopedUpdatePobDtoRecognitionPattern
            - type: 'null'
          description: The revenue recognition pattern
        eventTypeId:
          type:
            - string
            - 'null'
          description: Event type ID for RECOGNIZE_AS_CONSUMED pattern
        productId:
          type:
            - string
            - 'null'
          description: The ID of the product this performance obligation is for
        serviceStartDate:
          type: string
          description: Service start date as YYYY-MM-DD string
        serviceEndDate:
          type: string
          description: Service end date as YYYY-MM-DD string
        transactionPrice:
          type: string
          description: Transaction price as a decimal string
      required:
        - id
      title: ContractScopedUpdatePobDto
    BatchSavePobsForContractDto:
      type: object
      properties:
        billingTermGroupId:
          type: string
          description: Billing term group ID (BTG) that all operations are scoped to
        toCreate:
          type: array
          items:
            $ref: '#/components/schemas/ContractScopedCreatePobDto'
          description: Performance obligations to create within the billing term group
        toUpdate:
          type: array
          items:
            $ref: '#/components/schemas/ContractScopedUpdatePobDto'
          description: >-
            Performance obligations to update (must belong to the billing term
            group)
        toDelete:
          type: array
          items:
            type: string
          description: Performance obligation IDs to delete
      required:
        - billingTermGroupId
        - toCreate
        - toUpdate
        - toDelete
      title: BatchSavePobsForContractDto
    BatchSavePerformanceObligationsResponseDtoErrorsItems:
      type: object
      properties: {}
      title: BatchSavePerformanceObligationsResponseDtoErrorsItems
    BatchSavePerformanceObligationsResponseDto:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/BatchSavePerformanceObligationsResponseDtoErrorsItems
          description: Array of errors if any operations failed
      title: BatchSavePerformanceObligationsResponseDto
    IntegratorsApiErrorDetails:
      type: object
      properties: {}
      description: Additional details about the error
      title: IntegratorsApiErrorDetails
    IntegratorsApiError:
      type: object
      properties:
        code:
          type: number
          format: double
          description: API response code
        message:
          type: string
          description: API response message
        details:
          $ref: '#/components/schemas/IntegratorsApiErrorDetails'
          description: Additional details about the error
      required:
        - code
        - message
      title: IntegratorsApiError
    Contracts_IntegratorsApiContractsv3Controller_batchSavePobsForContract_Response_200:
      type: object
      properties:
        payload:
          $ref: '#/components/schemas/BatchSavePerformanceObligationsResponseDto'
          description: Response payload, will be empty when success is false
        success:
          type: boolean
          description: Boolean with true=success, false=failure
        message:
          type: string
          description: Plain-text description of the result
        error:
          $ref: '#/components/schemas/IntegratorsApiError'
          description: json element with any error messages or warnings
      required:
        - payload
        - success
        - message
        - error
      title: >-
        Contracts_IntegratorsApiContractsv3Controller_batchSavePobsForContract_Response_200
  securitySchemes:
    custom-header:
      type: apiKey
      in: header
      name: Authorization

```

## Examples



**Request**

```json
{
  "billingTermGroupId": "123e4567-e89b-12d3-a456-426614174000",
  "toCreate": [
    {
      "serviceStartDate": "2024-07-01",
      "serviceEndDate": "2024-12-31",
      "transactionPrice": "1500.75"
    }
  ],
  "toUpdate": [
    {
      "id": "987f6543-e21b-45d3-b789-123456789abc"
    }
  ],
  "toDelete": [
    "456e7890-a12b-34d5-c678-987654321def"
  ]
}
```

**Response**

```json
{
  "payload": {
    "errors": [
      {}
    ]
  },
  "success": true,
  "message": "Batch save operation completed successfully.",
  "error": {
    "code": 0,
    "message": "",
    "details": {}
  }
}
```

**SDK Code**

```python
import requests

url = "https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations"

payload = {
    "billingTermGroupId": "123e4567-e89b-12d3-a456-426614174000",
    "toCreate": [
        {
            "serviceStartDate": "2024-07-01",
            "serviceEndDate": "2024-12-31",
            "transactionPrice": "1500.75"
        }
    ],
    "toUpdate": [{ "id": "987f6543-e21b-45d3-b789-123456789abc" }],
    "toDelete": ["456e7890-a12b-34d5-c678-987654321def"]
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"billingTermGroupId":"123e4567-e89b-12d3-a456-426614174000","toCreate":[{"serviceStartDate":"2024-07-01","serviceEndDate":"2024-12-31","transactionPrice":"1500.75"}],"toUpdate":[{"id":"987f6543-e21b-45d3-b789-123456789abc"}],"toDelete":["456e7890-a12b-34d5-c678-987654321def"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations"

	payload := strings.NewReader("{\n  \"billingTermGroupId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"toCreate\": [\n    {\n      \"serviceStartDate\": \"2024-07-01\",\n      \"serviceEndDate\": \"2024-12-31\",\n      \"transactionPrice\": \"1500.75\"\n    }\n  ],\n  \"toUpdate\": [\n    {\n      \"id\": \"987f6543-e21b-45d3-b789-123456789abc\"\n    }\n  ],\n  \"toDelete\": [\n    \"456e7890-a12b-34d5-c678-987654321def\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"billingTermGroupId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"toCreate\": [\n    {\n      \"serviceStartDate\": \"2024-07-01\",\n      \"serviceEndDate\": \"2024-12-31\",\n      \"transactionPrice\": \"1500.75\"\n    }\n  ],\n  \"toUpdate\": [\n    {\n      \"id\": \"987f6543-e21b-45d3-b789-123456789abc\"\n    }\n  ],\n  \"toDelete\": [\n    \"456e7890-a12b-34d5-c678-987654321def\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"billingTermGroupId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"toCreate\": [\n    {\n      \"serviceStartDate\": \"2024-07-01\",\n      \"serviceEndDate\": \"2024-12-31\",\n      \"transactionPrice\": \"1500.75\"\n    }\n  ],\n  \"toUpdate\": [\n    {\n      \"id\": \"987f6543-e21b-45d3-b789-123456789abc\"\n    }\n  ],\n  \"toDelete\": [\n    \"456e7890-a12b-34d5-c678-987654321def\"\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations', [
  'body' => '{
  "billingTermGroupId": "123e4567-e89b-12d3-a456-426614174000",
  "toCreate": [
    {
      "serviceStartDate": "2024-07-01",
      "serviceEndDate": "2024-12-31",
      "transactionPrice": "1500.75"
    }
  ],
  "toUpdate": [
    {
      "id": "987f6543-e21b-45d3-b789-123456789abc"
    }
  ],
  "toDelete": [
    "456e7890-a12b-34d5-c678-987654321def"
  ]
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"billingTermGroupId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"toCreate\": [\n    {\n      \"serviceStartDate\": \"2024-07-01\",\n      \"serviceEndDate\": \"2024-12-31\",\n      \"transactionPrice\": \"1500.75\"\n    }\n  ],\n  \"toUpdate\": [\n    {\n      \"id\": \"987f6543-e21b-45d3-b789-123456789abc\"\n    }\n  ],\n  \"toDelete\": [\n    \"456e7890-a12b-34d5-c678-987654321def\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "billingTermGroupId": "123e4567-e89b-12d3-a456-426614174000",
  "toCreate": [
    [
      "serviceStartDate": "2024-07-01",
      "serviceEndDate": "2024-12-31",
      "transactionPrice": "1500.75"
    ]
  ],
  "toUpdate": [["id": "987f6543-e21b-45d3-b789-123456789abc"]],
  "toDelete": ["456e7890-a12b-34d5-c678-987654321def"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://integrators.prod.api.tabsplatform.com/v3/contracts/123e4567-e89b-12d3-a456-426614174000/performance-obligations")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```